> A (PR)pull request is a method of submitting contributions to an open source project. It is often the preferred way of submitting contributions to a project using a Distributed Version Control System (DVCS) such as Git.

FreeCodeCamp is an Open Source project and all of the contents are freely editable.

- [Fork](https://help.github.com/articles/fork-a-repo/) the project on GitHub.
- [Clone](https://help.github.com/articles/cloning-a-repository/) it to a local machine.  Do not edit online in github.com, as the editor may cause issues with JSON formatted data.
- [Create a branch](https://help.github.com/articles/creating-and-deleting-branches-within-your-repository/) and make your changes in that branch and commit them.
- [Push](https://help.github.com/articles/pushing-to-a-remote/) the branch online (if editing locally).
- [Create a pull request](https://help.github.com/articles/creating-a-pull-request/) against the **"staging"** branch.
- The title (also called the subject) of your PR should be descriptive of your changes. i.e. `fix typo in basic-javascript challenge` 
- If the PR is meant to fix a specific issue, append to the end of your PR's commit message `closes #1337`. This tells GitHub to close that issue if the PR is merged.
- Do NOT add issue numbers to the title.

These are general guidelines for PR's that work across most projects. It gives everyone a quick guide to your changes when looking at the commit history of a project. 

*Note:  Not all pull requests are accepted. FCC project maintainers will explain the reason of non-acceptance.*

## Further Reading
* [GitHub & Git Foundations Training](https://www.youtube.com/playlist?list=PLg7s6cbtAD15G8lNyoaYDuKZSKyJrgwB-) - How to use Git and GitHub
* [FreeCodeCamp Contribution Guidelines](https://github.com/FreeCodeCamp/FreeCodeCamp#contributing)
* [How to write Git commit messages](http://chris.beams.io/posts/git-commit/)
* [How to Clone FCC to a Windows PC](https://github.com/FreeCodeCamp/FreeCodeCamp/wiki/How-to-clone-the-FreeCodeCamp-website-on-a-Windows-pc)